package com.hai.dao;

import com.hai.entity.HighGoodsPriceRefer;
import com.hai.entity.HighGoodsPriceReferExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighGoodsPriceReferMapper extends HighGoodsPriceReferMapperExt {
    @SelectProvider(type=HighGoodsPriceReferSqlProvider.class, method="countByExample")
    long countByExample(HighGoodsPriceReferExample example);

    @DeleteProvider(type=HighGoodsPriceReferSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighGoodsPriceReferExample example);

    @Delete({
        "delete from high_goods_price_refer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_goods_price_refer (object_type, object_id, ",
        "price_type, old_sale_price, ",
        "new_sale_price, promptly_type, ",
        "effective_time, invalid_time, ",
        "remark, create_time, ",
        "operator_id, operator_name, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{objectType,jdbcType=INTEGER}, #{objectId,jdbcType=BIGINT}, ",
        "#{priceType,jdbcType=INTEGER}, #{oldSalePrice,jdbcType=DECIMAL}, ",
        "#{newSalePrice,jdbcType=DECIMAL}, #{promptlyType,jdbcType=BIT}, ",
        "#{effectiveTime,jdbcType=TIMESTAMP}, #{invalidTime,jdbcType=TIMESTAMP}, ",
        "#{remark,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{operatorId,jdbcType=BIGINT}, #{operatorName,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighGoodsPriceRefer record);

    @InsertProvider(type=HighGoodsPriceReferSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighGoodsPriceRefer record);

    @SelectProvider(type=HighGoodsPriceReferSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="object_type", property="objectType", jdbcType=JdbcType.INTEGER),
        @Result(column="object_id", property="objectId", jdbcType=JdbcType.BIGINT),
        @Result(column="price_type", property="priceType", jdbcType=JdbcType.INTEGER),
        @Result(column="old_sale_price", property="oldSalePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="new_sale_price", property="newSalePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="promptly_type", property="promptlyType", jdbcType=JdbcType.BIT),
        @Result(column="effective_time", property="effectiveTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="invalid_time", property="invalidTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="remark", property="remark", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighGoodsPriceRefer> selectByExample(HighGoodsPriceReferExample example);

    @Select({
        "select",
        "id, object_type, object_id, price_type, old_sale_price, new_sale_price, promptly_type, ",
        "effective_time, invalid_time, remark, create_time, operator_id, operator_name, ",
        "`status`, ext_1, ext_2, ext_3",
        "from high_goods_price_refer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="object_type", property="objectType", jdbcType=JdbcType.INTEGER),
        @Result(column="object_id", property="objectId", jdbcType=JdbcType.BIGINT),
        @Result(column="price_type", property="priceType", jdbcType=JdbcType.INTEGER),
        @Result(column="old_sale_price", property="oldSalePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="new_sale_price", property="newSalePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="promptly_type", property="promptlyType", jdbcType=JdbcType.BIT),
        @Result(column="effective_time", property="effectiveTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="invalid_time", property="invalidTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="remark", property="remark", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighGoodsPriceRefer selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighGoodsPriceReferSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighGoodsPriceRefer record, @Param("example") HighGoodsPriceReferExample example);

    @UpdateProvider(type=HighGoodsPriceReferSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighGoodsPriceRefer record, @Param("example") HighGoodsPriceReferExample example);

    @UpdateProvider(type=HighGoodsPriceReferSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighGoodsPriceRefer record);

    @Update({
        "update high_goods_price_refer",
        "set object_type = #{objectType,jdbcType=INTEGER},",
          "object_id = #{objectId,jdbcType=BIGINT},",
          "price_type = #{priceType,jdbcType=INTEGER},",
          "old_sale_price = #{oldSalePrice,jdbcType=DECIMAL},",
          "new_sale_price = #{newSalePrice,jdbcType=DECIMAL},",
          "promptly_type = #{promptlyType,jdbcType=BIT},",
          "effective_time = #{effectiveTime,jdbcType=TIMESTAMP},",
          "invalid_time = #{invalidTime,jdbcType=TIMESTAMP},",
          "remark = #{remark,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighGoodsPriceRefer record);
}